#include <REG_MG82FG5Dxx.H>

/**********************Define Variable****************************/
#define uint8_t unsigned char
#define uint16_t unsigned int
#define uint32_t unsigned long
	
#define Dev_Addss (0x80)

#define _TWSI_TIME_MAX_		2000

/**********************Global Variable****************************/
//static uint16_t Temp_Value = 0;
uint8_t TWI0_Err;
uint8_t Read_Data_E[2] = {0};
uint8_t Us_Data_1 = 0;
uint16_t Read_D = 0;
double Cal_Value_V2 = 0;
long Cal_Value_V1 = 0;



/**********************Function Decleartion***********************/

void Init_I2C(void);
uint16_t Read_Measure_Value(void);
void Timer_Init(void);
void delay(unsigned int value);


/*
/**********************Init_I2C***********************************
* @	Function  : Init_I2C
*	@ Input		  : Void
* @ Output    : Void
* Description : Initialize the I2C pin and clock 
/*****************************************************************
*/

void Init_I2C(void)
{
	SICON = 0x00;
	
	//================================
	//I2C_SCL=P6.0,I2C_SDA=P6.1 
	SFRPI = 1;
	P6M0 	= P6M0|(P6M00 | P6M01);
	SFRPI = 3;
	P6M1 	= P6M1|(P6M00 | P6M01);
	SFRPI = 0;
	AUXR3 &= ~TWIPS1;
	AUXR3 |= TWIPS0;
	//================================
	
	//================================
	//I2C_SCL=P3.0,I2C_SDA=P3.1
//	AUXR3 &= ~TWIPS0;
//	AUXR3 |= TWIPS1;
	//================================
	
	SICON = (CR1 | CR0 | ENSI);
}

/*
/**********************Read_Measure_Value*************************
* @	Function  : Read_Measure_Value
*	@ Input		  : Void
* @ Output    : 16 - bit read the value.
* Description : Read Temperature & Humidity value 
/*****************************************************************
*/
uint16_t Read_Measure_Value(void)
{
	uint8_t Us_Data = 0;
	static uint16_t cnt = 0;
	
	//I2C Start
	SICON 	|= STA;
	SICON		&= ~SI;
	cnt = 0;
	while( (SICON&SI) != SI)
	{
		cnt++;
		if(cnt > _TWSI_TIME_MAX_)
		{	
			TWI0_Err = 1;
			goto Read_End;
		}
	}
	SICON 	&= ~STA;
	
	//Send Device Address
	SIDAT		= Dev_Addss;
	SICON		&= ~SI;
	cnt = 0;
	while( (SICON&SI) != SI)
	{
		cnt++;
		if(cnt > _TWSI_TIME_MAX_)
		{	
			TWI0_Err = 1;
			goto Read_End;
		}
	}
	
	// Write User - Register address
	SIDAT		= 0xE6;
	SICON		&= ~SI;
	cnt = 0;
	while( (SICON&SI) != SI)
	{
		cnt++;
		if(cnt > _TWSI_TIME_MAX_)
		{	
			TWI0_Err = 1;
			goto Read_End;
		}
	}
	
	// User - Register value
	SIDAT		= 0x41;				
	SICON		&= ~SI;
	cnt = 0;
	while( (SICON&SI) != SI)
	{
		cnt++;
		if(cnt > _TWSI_TIME_MAX_)
		{	
			TWI0_Err = 1;
			goto Read_End;
		}
	}

	//I2C Stop
	SICON  |= STO;
	SICON		&= ~SI;
	cnt = 0;
	while((SICON&STO) == STO)
	{
		cnt++;
		if(cnt > _TWSI_TIME_MAX_)
		{	
			TWI0_Err = 1;
			goto Read_End;
		}
	}
	delay(1);
	
	//I2C Start
	SICON 	|= STA;
	SICON		&= ~SI;
	cnt = 0;
	while( (SICON&SI) != SI)
	{
		cnt++;
		if(cnt > _TWSI_TIME_MAX_)
		{	
			TWI0_Err = 1;
			goto Read_End;
		}
	}
	SICON 	&= ~STA;
	
	//Send Device Address
	SIDAT		= Dev_Addss;
	SICON		&= ~SI;
	cnt = 0;
	while( (SICON&SI) != SI)
	{
		cnt++;
		if(cnt > _TWSI_TIME_MAX_)
		{	
			TWI0_Err = 1;
			goto Read_End;
		}
	}
	
	// Temperature & Humidity Command
	SIDAT		= 0xE3;					// For Temperature = E3 & For Humidity = E5
	SICON		&= ~SI;
	cnt = 0;
	while( (SICON&SI) != SI)
	{
		cnt++;
		if(cnt > _TWSI_TIME_MAX_)
		{	
			TWI0_Err = 1;
			goto Read_End;
		}
	}	
	
	//I2C Re-Start
	SICON 	|= STA;
	SICON		&= ~SI;
	cnt = 0;
	while( (SICON&SI) != SI)
	{
		cnt++;
		if(cnt > _TWSI_TIME_MAX_)
		{	
			TWI0_Err = 1;
			goto Read_End;
		}
	}
	SICON 	&= ~STA;
	
	//Send Device Address
	SIDAT		= Dev_Addss | 0x01;//Read
	SICON		&= ~SI;
	cnt = 0;
	while( (SICON&SI) != SI)
	{
		cnt++;
		if(cnt > _TWSI_TIME_MAX_)
		{	
			TWI0_Err = 1;
			goto Read_End;
		}
	}
	delay(1);
	// Read Sensor value
	SICON		&= ~SI;
	cnt = 0;
	while( (SICON&SI) != SI)
	{
		cnt++;
		if(cnt > _TWSI_TIME_MAX_)
		{	
			TWI0_Err = 1;
			goto Read_End;
		}
	}
	Us_Data = SIDAT;

	SICON		&= ~SI;
	cnt = 0;
	while( (SICON&SI) != SI)
	{
		cnt++;
		if(cnt > _TWSI_TIME_MAX_)
		{	
			TWI0_Err = 1;
			goto Read_End;
		}
	}
	Us_Data_1 = SIDAT;
	
	//I2C Stop
	SICON  |= STO;
	SICON		&= ~SI;
	cnt = 0;
	while((SICON&STO) == STO)
	{
		cnt++;
		if(cnt > _TWSI_TIME_MAX_)
		{	
			TWI0_Err = 1;
			goto Read_End;
		}
	}
	
	Read_D = Us_Data;
	Read_D |= Us_Data_1<<8;
	
	Read_End:
	return(Read_D);
}

/*
/**********************delay**************************************
* @	Function  : delay
*	@ Input		  : 32 - bit delay value
* @ Output    : Void
* Description : 1 mS delay 
/*****************************************************************
*/
void delay(unsigned int value)
{
	unsigned int j,i;
	for(j=0; j<value; j++)
	{
		for(i=0; i<500; i++);
	}
}

/*
/**********************Timer_Init*********************************
* @	Function  : Timer_Init
*	@ Input		  : void
* @ Output    : Void
* Description : Initialize timer for SCL
/*****************************************************************
*/

void Timer_Init(void)
{
	AUXR2 = T0X12;
}

/*
/**********************Main***************************************
* @	Function  : Main
*	@ Input		  : void
* @ Output    : Void
* Description : -
/*****************************************************************
*/

void main(void)
{
	uint8_t v =0;
	CKCON0 &= ~AFS;
	Timer_Init();
	Init_I2C();
	while(1)
	{
		for(v=0; v<3; v++)
		{
			Read_Data_E[v] = Read_Measure_Value();
		}
		Cal_Value_V1 = Read_Data_E[0];
		Cal_Value_V1 <<= 8;
		Cal_Value_V1 |= Read_Data_E[1];
		Cal_Value_V1 *= 21965;
		Cal_Value_V1 >>= 13;
		Cal_Value_V2 = Cal_Value_V1;
		Cal_Value_V2 /= 10;
		Cal_Value_V2 -= 4687;
		Cal_Value_V2 /= 100;
	}
}